package ui.controller;

import java.util.ArrayList;

import classes.Category;
import classes.CpsObject;
import classes.HolonElement;
import classes.HolonObject;
import ui.model.Model;

public class SearchController {

	private Model MODEL;

	public SearchController(Model model) {
		this.MODEL = model;

	}
	
	/**
	 * search for category
	 * 
	 * @param name
	 * @return
	 */
	public Category searchCategory(String category) {

		for (Category cat : MODEL.getCategories()) {
			if (cat.getName().equals(category)) {
				return cat;
			}
		}
		return null;
	}
	
	/**
	 * Search for Object
	 * 
	 * @param object
	 * @param list
	 * @return
	 */
	public CpsObject searchHolonObject(String object, ArrayList<CpsObject> list) {
		for (CpsObject objects : list) {
			if (objects.getObjName().equals(object))
				return objects;
		}
		return null;
	}

	/**
	 * Search for Object by ID
	 * 
	 * @param ID
	 * @param list
	 * @return
	 */
	public CpsObject searchByID(int ID) {
		for (CpsObject objects : MODEL.getObjectsOnCanvas()) {
			if (objects.getID() == ID)
				return objects;
		}
		return null;
	}

	/**
	 * Search for Element
	 * 
	 * @param object
	 * @param element
	 * @return
	 */
	public HolonElement searchHolonElement(HolonObject object, String element) {

		if (object.getElements() != null) {
			for (HolonElement ele : object.getElements()) {
				if (ele.getEleName().equals(element))
					return ele;
			}
		}
		return null;
	}

}
